<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<title>Products list</title>
<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.1/dist/css/bootstrap.min.css" rel="stylesheet" crossorigin="anonymous">
</head>
<body class="bg-light">
    
    <main class="d-flex flex-nowrap">
        
      <!-- Sidebar -->
      <div class="d-flex flex-column flex-shrink-0 p-3 text-bg-dark" style="width: 280px;">
        <a href="/" class="d-flex align-items-center mb-3 mb-md-0 me-md-auto text-white text-decoration-none">
          <svg class="bi pe-none me-2" width="40" height="32"><use xlink:href="#bootstrap"></use></svg>
          <span class="fs-4">Efficient Metrics</span>
        </a>
        <hr>
        <ul class="nav nav-pills flex-column mb-auto">
          <li class="nav-item">
            <a href="#" class="nav-link active" aria-current="page">
              <svg class="bi pe-none me-2" width="16" height="16"><use xlink:href="#home"></use></svg>
              Create new
            </a>
          </li>
          <li>
            <a href="#" class="nav-link text-white">
              <svg class="bi pe-none me-2" width="16" height="16"><use xlink:href="#speedometer2"></use></svg>
              Collections
            </a>
          </li>
        </ul>
      </div>
      <!-- /Sidebar -->
      <div class="b-example-divider b-example-vr"></div>
      <!-- Content -->
      <div class="d-flex flex-column flex-shrink-0 p-5 bg-light">
    
<?php

// Cache products
$VDEVShopifyProduct = $VDEVShopify->apiClass('product');
$products = $VDEVShopifyProduct->getProducts();

if (!empty($products)) {
    
    foreach ($products as $product) {
        
        if (!empty($product['id']) && !$database->getProductByShopifyId($product['id'])) {
            $database->saveProduct($product);
        }
    }
}

?>

<div class="container">
   <main style="max-width: 450px; margin: 0 auto;">
        <h3 class="mb-3">Create a new collection</h3>
        <?php
        
        if (!empty($_GET['action']) && $_GET['action'] == 'create_collection') {
            
            if (!empty($_POST['collection']['title']) && !empty($_POST['collection']['q'])) {
                $collectionTitle = $_POST['collection']['title'];
                $collectionQ = trim($_POST['collection']['q']);
                
                $VDEVShopifyCollection = $VDEVShopify->apiClass('collection');
                
                $collectionHandle = trim($collectionTitle);
                $collectionHandle = mb_strtolower($collectionHandle, 'utf-8');
                $collectionHandle = preg_replace('/[^\-0-9a-z]+/', '-', $collectionHandle);
                $collectionHandle .= '-list';
                
                $collectionObj = $VDEVShopifyCollection;
                
                $collection = $collectionObj->addCollection([
                    'title' => $collectionTitle,
                    'handle' => $collectionHandle
                ], true);
                
                if (empty($collection['id'])) {
                    $error = $collectionObj->getLastCallError();
                    echo '<div class="alert alert-danger" role="alert"><b>Error:</b> ' . $error . '</div>';
                    
                } else if (!empty($collection['id'])) {
                    echo '<div class="alert alert-success" role="alert">Collection created. ID: ' . (int)$collection['id'] . '</div>';
                    
                    /* Products */
                    $products = $database->getProducts();   
                    $productPosition = 1;
                    
                    $collectionProducts = [];
                    $collectionProductsIDs = [];
                    
                    $collectionQWords = explode(" ", $collectionQ);
                    $collectionQWords = array_unique($collectionQWords);

                    foreach ($products as $product) {
                        $collectionProductWordsFound = 0;
                        
                        foreach ($collectionQWords as $collectionQWord) {
                            
                            if (preg_match('#(^|\>|\s|\.|\,)' . $collectionQWord . '($|\<|\s|\.|\,)#ui', $product['title']) || preg_match('#(^|\>|\s|\.|\,)' . $collectionQWord . '($|\<|\s|\.|\,)#ui', $product['description'])) {
                                
                                if (!in_array((int)$product['shopify_product_id'], $collectionProductsIDs)) {
                                    $collectionProductWordsFound++;
                                }
                            }
                        }
                                
                        if ($collectionProductWordsFound == count($collectionQWords)) {
                            $collectionProducts[] = [
                                'product_id' => (int)$product['shopify_product_id'],
                                'position' => $productPosition
                            ];
                            
                            $collectionProductsIDs[] = (int)$product['shopify_product_id'];
                        
                            $productPosition++;
                        }
                    }
                    
                    if (!empty($collectionProducts)) {
                        
                        $VDEVShopifyCollection->assignProductsToCustomCollection([
                            'id' => $collection['id'],
                            'collects' => $collectionProducts
                        ]);
                        
                        echo '<div class="alert alert-success" role="alert">' . ((int)$productPosition - 1) . ' products were assign to the new collection</div>';
                    }
                    
                    $database->addCollection([
                        'shopify_collection_id' => $collection['id'],
                        'title' => $collectionTitle,
                        'products_count' => (int)$productPosition - 1
                    ], true);
                    
                    
                    /* /Products */
                    
                    /* Footer links */
                    if (!empty($_POST['collection']['footer_links_collection_id'])) {
                        $footerLinksCollection = $VDEVShopifyCollection->getCollectionById((int)$_POST['collection']['footer_links_collection_id']);
                        
                        if (!empty($footerLinksCollection['id'])) {
                            echo '<div class="alert alert-success" role="alert">Footer links were updated</div>';
                            
                            $footerLinksCollectionMetafield = $VDEVShopifyCollection->getCollectionMetafields($footerLinksCollection, 'footer', 'links');
                            
                            if (!empty($footerLinksCollectionMetafield)) {
                                $footerLinks = json_decode($footerLinksCollectionMetafield, true);
                            
                            } else {
                                $footerLinks = [];
                            }
                            
                            $footerLinks[] = [
                                'title' => $collection['title'],
                                'url' => '/collections/' . $collection['handle']
                            ];
                    
                            $VDEVShopifyCollection->setCollectionMetafield(
                                [
                                    'id' => (int)$footerLinksCollection['id']
                                ],
                                [
                                    'namespace' => 'footer',
                                    'key' => 'links',
                                    'value' => json_encode($footerLinks)
                                ]
                            );
                        }
                    }
                    /* /Footer links */
                }
            }
        }
        
        ?>
        <!-- Form -->
        <form class="needs-validation" action="?access_token=<?= htmlspecialchars($_GET['access_token']) ?>&action=create_collection" method="POST">
            
            <div class="row g-3 mb-5">
                
                <div class="col-12">
                  <label for="firstName" class="form-label">Collection name</label>
                  <input type="text" name="collection[title]" class="form-control" id="firstName" placeholder="" value="" required="">
                </div>
                
                <div class="col-12">
                  <label for="firstName" class="form-label">Products keywords</label>
                  <input type="text" name="collection[q]" class="form-control" id="firstName" placeholder="" value="" required="">
                </div>
                    
                <div class="col-12">
                    <label for="collectonFooterLinksCollectionId" class="form-label">Assign to:</label>
                    <?php
        
                    $VDEVShopifyCollection = $VDEVShopify->apiClass('collection');
                    $collections = $VDEVShopifyCollection->getCollections(true);
        
                    ?>
                    <select class="form-select" id="collectonFooterLinksCollectionId" name="collection[footer_links_collection_id]" required="">
                        <option value="">
                            Select a collection
                        </option>
                        <?php foreach ($collections as $collection): ?>
                            <option value="<?= htmlspecialchars($collection['id']) ?>">
                                <?= $collection['title'] ?>
                                <?php
                                
                                $collectionMetafields = $VDEVShopifyCollection->getCollectionMetafields($collection);
                                $collectionFooterLinksMetafield = $VDEVShopifyCollection->getCollectionMetafields($collection, 'footer', 'links');
                                
                                ?>
                            </option>
                        <?php endforeach; ?>
                    </select>
                </div>
            </div>
          
            <button type="submit" class="w-100 btn btn-primary btn-lg" type="submit">
                Create
            </button>
        </form>
        <!-- /Form -->
        
        <?php $collections = $database->getCollections(); ?>
        <?php if (!empty($collections)): ?>
            <!-- Collections -->
            <div class="mt-3 pt-4 pb-5">
                <hr class="my-4">
                <h2 class="mt-5 mb-3">Created collections</h2>
                <div class="list-group w-auto">
                    <?php foreach ($collections as $collection): ?>
                        <label class="list-group-item d-flex gap-3">
                            <span class="pt-1 form-checked-content pb-1">
                                <strong><?= htmlspecialchars($collection['title']) ?></strong>
                                <small class="d-block text-muted" style="display: none !important;">
                                    <?= (int)$collection['products_count'] ?> products
                                </small>
                            </span>
                        </label>
                    <?php endforeach; ?>
                </div>
            </div>
            <!-- /Collections -->
        <?php endif; ?>
    </main>
</div>


      </div>
      <!-- /Content -->
    
    
    </main>




  <footer class="my-5 pt-5 text-muted text-center text-small" style="display: none;">
    <p class="mb-1">© 2022 Efficient Marketing</p>
    <ul class="list-inline">
      <li class="list-inline-item"><a href="#">Privacy</a></li>
      <li class="list-inline-item"><a href="#">Terms</a></li>
      <li class="list-inline-item"><a href="#">Support</a></li>
    </ul>
  </footer>
</body>
