<?php
include_once(__DIR__ . '/classes/vdevshopify.class.php');
include_once(__DIR__ . '/classes/database.class.php');

class Tools {

//    static $accessPassword = 'Efficient123!';
    static $accessPasswords = [
        'Oxford123!' => [
            'level' => 1
        ],
        'Efficient123!' => [
            'level' => 2
        ]
    ];
    
    public static function getShopCmsQuery($q, $type = 'search', $shop) {
        $data = [
            'default' => [
                'search' => '/search?view=ajax&type=product&section_id=ajax-collection-cms&q={{ q }}*',
                'collection' => '/collections/{{ q }}'
            ],
            'dkactive-staging.myshopify.com' => [
                'search' => '/search?type=product&section_id=predictive-search-cms&q={{ q }}*'
            ],
            'dk-active.myshopify.com' => [
                'search' => '/search?type=product&section_id=predictive-search-cms&q={{ q }}*',
                'collection' => '/collections/{{ q }}'
            ]
        ];
        
        $cmsQuery = $data['default'][$type];
        
        if (!empty($data[$shop][$type])) {
            $cmsQuery = $data[$shop][$type];
        }
        
        if ($type == 'search') {
            $cmsQuery = str_replace('{{ q }}', urlencode(trim($q)), $cmsQuery);
        }
            
        return $cmsQuery;
    }
    
    public static function getShop() {
        $shop = '';
        
        if (isset($_GET['shop'])) {
            $shop = $_GET['shop'];
        }
        
        return $shop;
    }
    
    public static function getController() {
        $controller = '';
        
        if (isset($_GET['controller'])) {
            $controller = $_GET['controller'];
        }
        
        return $controller;
    }
    
    public static function getAction() {
        $action = '';
        
        if (isset($_GET['action'])) {
            $action = $_GET['action'];
        }
        
        return $action;
    }
    
    public static function getMethod() {
        $method = '';
        
        if (isset($_GET['method'])) {
            $method = $_GET['method'];
        }
        
        return $method;
    }
    
    public static function getLink($controller = null, $action = null, $method = null) {
        $url = '?shop=' . self::getShop();
        
        if (!empty($_GET['access_token'])) {
            $url .= '&access_token=' . $_GET['access_token'];
        
            if (isset($controller)) {
                $url .= '&controller=' . $controller;
            
                if (isset($action)) {
                    $url .= '&action=' . $action;
            
                    if (isset($method)) {
                        $url .= '&method=' . $method;
                    }
                }
            }
        }
        
        return $url;
    }

//    public static function checkAccessPassword() {
//        return (!empty($_COOKIE['access_password']) && $_COOKIE['access_password'] == self::$accessPassword);
//    }

    public static function getAccessLevel() {

        if (!empty($_COOKIE['access_password']) && !empty(self::$accessPasswords[$_COOKIE['access_password']]['level'])) {
            return (int)self::$accessPasswords[$_COOKIE['access_password']]['level'];
        }

        return 0;
    }
}